'Drop Change file onto "ini_replace.vbs" and use a default Ini file (specified in line 18)
'or call with Cscript from Batch file passing both Ini and Change file as parameters

Const ForReading = 1
Const ForWriting = 2
Dim strIni						'String for holding the whole ini file
Dim strTemp                                                                           'Temporary string
Dim strBlock					'Section of ini to search in
Dim strOldText					'Original ini line in form Parameter=value
Dim strNewText					'New ini line in form Parameter=value
Dim FoundEq, FoundStart, FoundNext, FoundAt, FoundCR	'Locators

strFilename1 = Wscript.Arguments(0)
If instr(strFilename1, "i_view32.ini") > 0 then		'Ini file was passed as first parameter
  strFilename2 = Wscript.Arguments(1)			'Changes file passed as 2nd parameter
Else
  strFilename2 = strFilename1  				'Changes file was passed as first parameter
  strFilename1 = "C:\Users\Public\Irfanview\i_view32.ini" 		'Use a default IV ini file
End If

Set objFSO = CreateObject("Scripting.FileSystemObject") 	   'Create a File System Object 
Set objFile = objFSO.OpenTextFile(strFilename1, ForReading)     'Open ini file, read whole of it into a string
strIni = objFile.ReadAll
objFile.Close

clean_up(strIni)
FoundStart = 1					    'Find entries anywhere in string
FoundEnd = Len(strIni)
				
Set objFile = objFSO.OpenTextFile(strFilename2, ForReading)	     'Open changes file and read line by line
  Do While objFile.AtEndOfStream <> True
    strNewText = objFile.ReadLine
    strNewText = Replace(strNewText,vbCr,"")                              'Remove any stray carriage returns (just in case..)
    strNewText = Replace(strNewText,vbLf,"")                              'Remove any stray line feeds (just in case..)
    If  Left(strNewText,1) = "[" then process_header     		'This is a block header 
    FoundEq = Instr(strNewText,"=")				'Find position of = sign in line
    If FoundEq >3 Then process_entry
  Loop 
objFile.Close

Set objFile = objFSO.OpenTextFile(strFilename1, ForWriting)		'Open Ini file and replace contents	
   objFile.Write strIni	
objFile.Close

sub clean_up(strTemp)
Do While Right(strTemp,2) = vbCrLf			        'Strip off all trailing empty lines
  strTemp = Left(strTemp, Len(strTemp)-2)
Loop
strTemp  = strTemp & vbCrLf				      'Add back the final EOL
End sub

Sub process_header	
strBlock=strNewText   
FoundStart = Instr(1, strIni, strBlock)			     'Allow to find entries only in this block
If FoundStart > 0 then
   FoundEnd = Instr(FoundStart+2, strIni, "[") - 1	
   If FoundEnd < 0 then FoundEnd = Len(strIni)
   If Right(Left(strIni,FoundEnd),2)=vbCrLf then FoundEnd=FoundEnd-2
   wscript.Echo "Found " & strBlock & " at " & FoundStart & "-" & FoundEnd		'Report block size
Else
    strIni = strIni & strNewText & vbCrLf 		                ' Create new section
    FoundStart = Len(strIni)				'Only allow new entries here
    FoundEnd =FoundStart			
    wscript.Echo "New entry " & strNewText & " at " & FoundEnd			'Report as new block
End If
End Sub

Sub process_entry  
 strOldText=Left(strNewText, FoundEq)				'Truncate after = sign
 FoundAt = Instr(FoundStart, strIni, strOldText)			'Find truncated string in Ini
 If FoundAt > FoundStart AND FoundAt < FoundEnd  Then
     FindEol = Instr(FoundAt, strIni, vbCrLf)		      	'Find end of line
     strOldText=Mid(strIni, FoundAt, FindEol - FoundAt)    	     	'Get whole of old entry
     strIni = Replace(strIni, strOldText, strNewText, 1)		'Replace old entry with new one
     FoundEnd = FoundEnd + Len(strNewText) - Len(strOldText)	'Adjust end of section
     wscript.Echo strNewText &" replaced " & strOldText & " at " & FoundAt		'Report entry replaced
 Else							 'Create new entry 
     strIni = Left(strIni, FoundEnd) & strNewText & vbCrLf & Right(strIni, Len(strIni) - FoundEnd)
     FoundEnd = FoundEnd + Len(strNewText) + 2			 'Adjust end of section
     wscript.Echo "New entry " & strNewText & " at " & FoundEnd			'Report as new entry
End If
End Sub      
